



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C#_委托</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C#_委托</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 04:24:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>委托属于C#中的新名词，它的应用也非常广泛，例如事件就是委托最简单而又直接的例子。</p>
<p>那么首先说说什么是委托，其实委托在用过C或者C++的人看来就是函数指针，不过使用C#的大多数人都没有用过这两门语言，因此对委托的理解不是很深，对于委托可以简单的从字面去理解，即&ldquo;委托别人去执行某些操作&rdquo;，也就是说执行一个操作，而这个操作过程自身并不知道，只是委托过来让你去执行而已。</p>
<p>参看如下这个例子。</p>
<p>public delegate void HelloHandler( string Msg );</p>
<p>private void SayHello( string sMsg )</p>
<p>{</p>
<p>MessageBox.Show( sMsg );</p>
<p>}</p>
<p>// delegate sample</p>
<p>HelloHandler hHello = new HelloHandler( SayHello );</p>
<p>hHello( "Hello World!" );</p>
<p>例子很明显，在执行hHello的时候，并不知道具体的过程是什么样的，只是去执行而已。</p>
<p>现在要说说委托能做些什么，那么先来分析一下事件，这也是委托用得最多的地方。一般事件的初始化需要绑定一个事件处理函数，那么当事件触发的时候，处理函数会被调用，也就是说在事件处理函数可以明确的知道，此事件是被触发了。例如，点击窗体的上的Button，它会把Click事件反馈给窗体。<strong>很明显，委托是处理对象之间的信息交互。除了事件外，委托的大多用处都和此类似，那么这样使用的好处在于降低对象之间耦合性。</strong></p>
<p>其次委托不同于以前函数指针的地方在于，可以绑定多个委托函数，例如：</p>
<p>public delegate void HelloHandler( string Msg );</p>
<p>private void WriteHello1( string sMsg )</p>
<p>{</p>
<p>Debug.WriteLine( "WriteHello1:" + sMsg );</p>
<p>}</p>
<p>private void WriteHello2( string sMsg )</p>
<p>{</p>
<p>Debug.WriteLine( "WriteHello2:" + sMsg );</p>
<p>}</p>
<p>// delegate sample</p>
<p>HelloHandler hHello = new HelloHandler( WriteHello1 );</p>
<p>hHello += new HelloHandler( WriteHello2 );</p>
<p>hHello( "Hello World!" );</p>
<p><strong>不过在这种情况下，由于绑定到委托上的函数是按照顺序执行的，所以有两个潜在的问题。</strong></p>
<p><strong>第一个问题，当一个函数执行过程中产生异常，导致后面的不能进行执行。就上面的例子而言，如果在&ldquo;WriteHello1</strong><strong>&rdquo;函数中出现异常，会导致&ldquo;WriteHello2</strong><strong>&rdquo;不能被执行。</strong></p>
<p><strong>另一个问题，就是委托执行的返回值，当绑定多个函数，委托执行的返回值是最后一个绑定函数执行后的返回值，那么通过这个值去做判断将会是不正确的。</strong></p>
<p>那么对于委托绑定多个函数，要注意的是不要把异常扩散出来，其次委托类型的返回值为&ldquo;void&rdquo;。</p>
<p>如何去使用委托，很多人看了书上的例子，也知道委托的意义，但是无法把它和实际应用进行结合。那么在使用委托的时候，首先要明白几个问题，等各个问题清楚了，委托原型也就自然出来了。</p>
<p><strong>需要分析清楚的问题有如下几点。</strong></p>
<p><strong>问题一，传递信息是什么，传递的时机是否固定，一次传递还是多次传递；</strong></p>
<p><strong>问题二，用委托是否合适；</strong></p>
<p><strong>问题三，哪一方是委托的调用端，而哪一方是委托的初始端；</strong></p>
<p><strong>问题四，委托的初始化放在哪里比较合适。</strong></p>
<p>问题一是关键，这首先决定是否要使用委托来实现，其次如果要使用委托，那么需要确定委托函数类型。</p>
<p>对于问题二来说，很多人可能就不解了。没错，委托是可以降低类型之间的耦合性，但是能起到这种作用的并不是只有委托这一种方法。很多情况下，用重载构造函数即可以达到这一目的，因此想问题的时候，不能局限于此。例如，很多人都做过弹出一个单独窗体对某一条记录进行修改，这里用委托可以实现，但是考虑到DataRow属于引用类型，而这个窗体脱离了数据记录就失去了意义，因此可以重载构造函数，在初始化窗体的时候，把记录传递给窗体就行了。相对而言，后者会更简单直接些。</p>
<p>有了前两个问题的分析，不少人在写委托的时候，会把顺序写反了，因此程序执行的效果并不是设想中的那样，这一点要尤为注意。</p>
<p>对于第四个问题来说，可以借鉴窗体的控件事件初始化部分代码，即委托的初始化采取就近原则，不过这不是唯一初始化的地方，这样写只是便于防止漏写。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zjlj39.html">jfinal基本应用 --报主键重复</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96z62nq.html">unbuntu apahce 2 设置 多域名</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zx4rnq.html">【POJ 2480】Longge&amp;&num;39&semi;s problem（欧拉函数）</a>
		</li>
						<li><a href="https://www.batexi.com/a/39056zmq.html">用jxl解析excel内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8znr238.html">页面路由跳转地址-get方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1lvej9.html">Excel：您尝试打开的文件的格式与文件扩展名指定的格式不一致</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x4pe68.html">request&period;getParamer&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zokww3q.html">&lbrack;妙味 DOM&rsqb; 第二课：DOM、BOM相关方法及属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpmxo69.html">浅谈ssh&lpar;struts&comma;spring&comma;hibernate三大框架&rpar;整合的意义及其精髓</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoj5e1q.html">win7下用SSH连接linux虚拟机</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojpyxlq.html">Flask 部署和分发</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy17wwmq.html">Spring Cloud &commat;HystrixCommand和&commat;CacheResult注解使用，参数配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjg4z38.html">Mybatis插入数据返回主键ID</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y5zjg8.html">webpack4加载字体</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdz1ed9.html">Linux查看设备命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wxk0rq.html">C&plus;&plus;字节对齐与位域</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ojorg8.html">mysql优化：慢查询分析、索引配置优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwe0zd8.html">自学Linux Shell12&period;4-for命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwljzml9.html">本地git库gitlab库链接服务器库 idea git 配置 gitlab 配置 git生成ssh公钥</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpen679.html">Zabbix-Agent在主动模式启动服务后，提示no active checks on server &lbrack;139&period;219&period;xx&period;xx&colon;10051&rsqb;&colon; host &lbrack;139&period;219&period;xx&period;xx&rsqb; not found</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8e4pd5k9.html">postgresql 获取所有表名、字段名、字段类型、注释</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw6mxj9.html">SQL删除多列语句</a>
			</li>
						<li><a href="https://www.batexi.com/a/q257r63q.html">VUE中v-on&colon;click事件中获取当前dom元素</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj3wz69.html">减少MySQL的Sleep进程有效方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5jjymq.html">UIButton vs UIEventListener 事件处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o4nnpeq.html">使用Swoole 构建API接口服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkg1m18.html">beta冲刺&mdash;&mdash;&mdash;&mdash;第四天（4&sol;5）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kdjwoq.html">团队作业&mdash;&mdash;Beta冲刺4</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdj0pjvq.html">团队作业&mdash;&mdash;Alpha冲刺 8&sol;12</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwlkj5l9.html">ubuntu环境下docker的安装与操作</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
